package com.steerinfo.ems.emsscqklg.controller;

import com.steerinfo.ems.emsscqklg.model.EmsScqkLg;
import com.steerinfo.ems.emsscqklg.service.IEmsScqkLgService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * EmsScqkLg RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-19 10:43
 * 类描述
 * 修订历史：
 * 日期：2021-10-19
 * 作者：generator
 * 参考：
 * 描述：EmsScqkLg RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/emsscqklgs")
public class EmsScqkLgController extends BaseRESTfulController {

    @Autowired
    IEmsScqkLgService emsScqkLgService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsscqklg:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsScqkLg> list = emsScqkLgService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsscqklg:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsScqkLg> list = emsScqkLgService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据EmsScqkLg对象创建")
    @ApiImplicitParam(name = "emsScqkLg", value = "详细实体emsScqkLg", required = true, dataType = "EmsScqkLg")
    //@RequiresPermissions("emsscqklg:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute EmsScqkLg model){
        EmsScqkLg emsScqkLg = emsScqkLgService.add(model);
        return success(emsScqkLg);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Date")
    //@RequiresPermissions("emsscqklg:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable Date id){
        EmsScqkLg emsScqkLg = emsScqkLgService.getById(id);
        return success(emsScqkLg);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的emsScqkLg信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Date"),
        @ApiImplicitParam(name = "emsScqkLg", value = "详细实体emsScqkLg", required = true, dataType = "EmsScqkLg")
    })
    //@RequiresPermissions("emsscqklg:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable Date id, @RequestBody EmsScqkLg model){
        model.setId(id);
        EmsScqkLg emsScqkLg = emsScqkLgService.modify(model);
        return success(emsScqkLg);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Date")
    //@RequiresPermissions("emsscqklg:delete")
    @DeleteMapping(value = "/{id}")//Date
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<Date> ids = ListUtils.convertList(list);
			  emsScqkLgService.delete(ids);
    	}
      return success();
    }
}
